// pages/welfareMall/personal/personal.js
import WelfareMall from '../../../api/welfareMall'
import activity from '../../../api/activity'
import {getMobileCache, getPhoneNumberNew as getPhoneNumberSync, getColor} from '../../../utils/user'
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isLogin: false,
    mobileTop: '',
    countNum: 0,
    grayTheme:false,
    navigationList:[],
    couponPath: false,
    avatarUrl : 'https://mmbiz.qpic.cn/mmbiz/icTdbqWNOwNRna42FI242Lcia07jQodd2FJGIYQfG0LAJGFxM4FbnQP6yfMxBgJ0F3YRqJCJ1aPAK2dQagdusBZg/0',
    hasUserInfo:false,
    personHeadList: [],
    staffImgList: [],
    config: {},

  },
  onChooseAvatar(e) {
    console.log(e.detail)
    this.setData({
      avatarUrl: e.detail.avatarUrl 
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  getCountNum: async function(){
  /**
   * 福利社
   */
    let resBuy = await WelfareMall.getUserCouponSnNum({
      mobile: getMobileCache(),
    });
    return Number(resBuy.data.num)
  },

  // 授权手机号
  getPhoneNumber(e) {
    getPhoneNumberSync(e, async () => {
        let nums = await this.getCountNum();
        this.setData({
            isLogin: true,
            mobileTop: getMobileCache(),
            countNum: nums,
        })       
    })
  },

  // 授权手机号--跳转导航栏
  getPhoneNav(e) {
    getPhoneNumberSync(e, async () => {
        let nums = await this.getCountNum();
        this.setData({
            isLogin: true,
            mobileTop: getMobileCache(),
            countNum: nums,
        });
        this.goToCoupon(e);  
    })
  },

  // 授权手机号--跳转导航栏
  getPathCoupon(e) {
    console.log(e)
    getPhoneNumberSync(e, async () => {
        let nums = await this.getCountNum();
        console.log(nums)
        this.setData({
            isLogin: true,
            mobileTop: getMobileCache(),
            countNum: nums,
        });
        this.getCouponPath(e);  
    })
  },

  // 员工通道
  getStaff(e) {
    console.log(e)
    getPhoneNumberSync(e, async () => {
        let nums = await this.getCountNum();
        console.log(nums)
        this.setData({
            isLogin: true,
            mobileTop: getMobileCache(),
            countNum: nums,
        });
        this.toStaff(e);  
    })
  },

  // 动态获取导航栏
  async getIndexList(){
    let res =  await WelfareMall.getPersonalData();
    await this.getPath(res.data.navigationList);
    let info =  await getColor();
    this.setData({
      navigationList:res.data.navigationList,
      personHeadList:info.personHeadList,
      staffImgList:info.staffImgList,
      config:info.config
    })
  },

  // 导航栏地址链接跳转
  goToCoupon:function(e){
    var appId = e.currentTarget.dataset.appid;
    var path = e.currentTarget.dataset.path;
  
    if(appId && path){
      wx.navigateToMiniProgram({
        appId: appId,
        path: path,
        success(res) {
          // 打开成功
        }
      })
    }
    
    if(!appId && path){
      wx.navigateTo({
        url: path,
      })
    }
   
  },

  /**
   * 活动列表我的券包路径
   * @param {*} nums 
   */
  getPath: async function(res){
    if(res != null && res.length > 0){
      for(var i = 0;i<res.length;i++){
        if("/pages/welfareMall/coupon/coupon" == res[i].path){
         this.setData({
           couponPath: true,
         })    
         return;
        }
      }
   }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: async function () {
      this.setData({
          grayTheme: app.globalData.grayTheme
      })
    this.getIndexList();
    let  userMobile = await activity.getMobileCache();
    if (userMobile.length !== 0) {

      this.setData({
        isLogin: true,
        mobileTop: userMobile,
      })
      
    }
    var userInfo = wx.getStorageSync("userInfo");
    if (userInfo.avatarUrl && userInfo.nickName) {
      this.setData({
        userInfo: userInfo,
        hasUserInfo:true
      })
    }


   
    if(this.data.isLogin){
      let nums = await this.getCountNum();
      this.setData({
        countNum: nums,
      })
    }

  },

  getCouponPath(e) {
    const url = "/pages/welfareMall/coupon/coupon"
    wx.navigateTo({
        url
    })
  },

  toStaff(e) {
    const url = "/pages/welfareMall/staff/distinguish"
    wx.navigateTo({
        url
    })
  },
  logout(){
    wx.removeStorageSync('userInfo');
    this.setData({
      isLogin:false,
      countNum:0,
      hasUserInfo:false
    })
   
  },

  getUserProfile: function(e){
    wx.getUserProfile({
      desc: '用于完善会员资料', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
      success: (res) => {
        console.log(res);
        var openId = wx.getStorageSync('loginInfo').openId;
        var mobile = getMobileCache();
        if(openId && mobile){
          activity.saveUser(openId,mobile,res.userInfo.avatarUrl,res.userInfo.nickName);

          var userInfo = {
            mobile:mobile,
            avatarUrl:res.userInfo.avatarUrl,
            nickName:res.userInfo.nickName,
          }
          wx.setStorageSync('userInfo',userInfo);
        }
      
        this.setData({
          userInfo: res.userInfo,
          hasUserInfo: true
        })
        // this.userRecruitInfo(res.userInfo.openId)
      }
    })
  },
  handlePageSizes(e) {
    this.setData({
      bodyImageHeight: e.detail.bodyImageHeight
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})